<?php

namespace EventPortal\Seeds;

use EventPortal\Domain\Permission\Models\Permission;
use EventPortal\Domain\Permission\Models\Role;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Seeder;

class RoleSeeder extends Seeder
{
    public function run(): void
    {
        $role = Role::create([
            'name' => 'super-admin',
            'label' => 'Super Admin',
        ]);

        Permission::all()->each(function (Permission $permission) use ($role): void {
            $role->givePermissionTo($permission);
        });

        $role = Role::create([
            'name' => 'admin',
            'label' => 'Admin',
        ]);

        Permission::query()
            ->whereHas('group', function (Builder $query) {
                return $query
                    ->where('name', 'event-management')
                    ->orWhere('name', 'team-management');
            })
            ->each(function (Permission $permission) use ($role): void {
                $role->givePermissionTo($permission);
            });
    }
}
